{% extends "customers/base.html" %}
{% load i18n %}
{% load staticfiles %}
{% load active_tag %}
{% load md2 %}

{% block title %}Bonificaciones{% endblock %}

{% block extra_head %}
<link href="{% static 'theme/plugins/c3/c3.min.css' %}" rel="stylesheet" type="text/css">
<link href="{% static 'theme/plugins/smartwizard/dist/css/smart_wizard.min.css' %}" rel="stylesheet" type="text/css">
<link href="{% static 'assets/plugins/datatables.net-bs4/css/dataTables.bootstrap4.min.css' %}" rel="stylesheet" />
<link href="{% static 'assets/plugins/datatables.net-responsive-bs4/css/responsive.bootstrap4.min.css' %}" rel="stylesheet" />
<link href="{% static 'assets/plugins/datatables.net-select-bs/css/select.bootstrap.min.css' %}" rel="stylesheet" />
<!--<link href="{% static 'assets/plugins/select/select.css' %}" rel="stylesheet" />-->
{% endblock extra_head %}

{% block pagelevelcss %}
<style>
	.square{
        font-family: sans-serif;
        font-size: 18px;
        font-weight: 400;
        color: #ffffff;
        background: #348fe2;
        margin: 0 0 25px;
        overflow: hidden;
        padding: 20px;
        margin-top: 30px;
    }
</style>
{% endblock %}

{% block page %}
<!-- begin breadcrumb -->
<ol class="breadcrumb float-xl-right">
		<li class="breadcrumb-item"><a href="{% url 'home' %}">Home</a></li>
		<li class="breadcrumb-item"><a href="{% url 'item-list' %}">Items</a></li>
    <li class="breadcrumb-item active">Proceso Items</li>
	</ol>
	<!-- end breadcrumb -->

	<!-- begin page-header -->
	<h1 class="page-header">Items</h1>
	<!-- end page-header -->

		<!-- begin row -->
		<div class="row">
				<!-- begin col-12 -->
				<div class="col-xl-12 ui-sortable">
					<!-- begin panel -->
					<div class="panel panel-inverse" data-sortable-id="ui-general-1">
						<!-- begin panel-heading -->
						<div class="panel-heading ui-sortable-handle">
							<h4 class="panel-title">Proceso de Items</h4>
							<div class="panel-heading-btn">
								<a href="javascript:;" class="btn btn-xs btn-icon btn-circle btn-default" data-click="panel-expand"><i class="fa fa-expand"></i></a>
								<a href="javascript:;" class="btn btn-xs btn-icon btn-circle btn-success" data-click="panel-reload"><i class="fa fa-redo"></i></a>
								<a href="javascript:;" class="btn btn-xs btn-icon btn-circle btn-warning" data-click="panel-collapse"><i class="fa fa-minus"></i></a>
								<a href="javascript:;" class="btn btn-xs btn-icon btn-circle btn-danger" data-click="panel-remove"><i class="fa fa-times"></i></a>
							</div>
						</div>
						<!-- end panel-heading -->
						<!-- begin panel-body -->
						<div class="panel-body">
							<div id="item-process-app">
                                {% csrf_token %}
                                <div id="wizard">
                                    <!-- begin wizard-step -->
                                    <ul>
                                        <li>
                                            <a href="#step-1">
                                                <span class="number">1</span> 
                                                <span class="info">
                                                    Trabajadores
                                                </span>
                                            </a>
                                        </li>
                                        <li>
                                            <a href="#step-2">
                                                <span class="number">2</span> 
                                                <span class="info">
                                                    Beneficios
                                                </span>
                                            </a>
                                        </li>
                                        <li>
                                            <a href="#step-3">
                                                <span class="number">3</span>
                                                <span class="info">
                                                    Descuentos
                                                </span>
                                            </a>
                                        </li>
                                        <li>
                                            <a href="#step-4">
                                                <span class="number">4</span> 
                                                <span class="info">
                                                    Factura
                                                </span>
                                            </a>
                                        </li>
                                    </ul>
                                    <div>
                                        <div id="step-1">
                                            <!-- begin fieldset -->
                                            <fieldset> 
                                                <!-- begin row -->
                                                <div>
                                                    <!-- begin col-8 -->
                                                    <button type="button" class="btn btn-outline-primary" onclick="selectAll()">Seleccionar Todos</button>
                                                    <button type="button" class="btn btn-outline-primary" onclick="deselectAll()">Deseleccionar Todos</button>
                                                    <table id="worker-list-wizard" cellspacing="0"  class="table table-striped table-bordered select">
                                                        <thead>
                                                          <tr>
                                                            <th style="text-align: center">Nombre</th>
                                                            <th style="text-align: center">Genero</th>
                                                            <th style="text-align: center">Fecha de Ingreso</th>
                                                            <th style="text-align: center">Posición</th>
                                                            <th style="text-align: center">Departamento</th>
                                                            <th style="text-align: center">Empresa</th>
                                                            <th style="text-align: center">Selección</th>
                                                          </tr>
                                                        </thead>
                                                        <tbody>
                                                        </tbody>
                                                    </table>
                                                    <!-- end col-8 -->
                                                </div>
                                                <!-- end row -->
                                            </fieldset>
                                            <!-- end fieldset -->
                                        </div>
                                        <div id="step-2">
                                            <!-- begin fieldset -->
                                            <fieldset> 
                                                <!-- begin row -->
                                                <div>
                                                    <!-- begin col-8 -->
                                                    <table id="bonification-list"  cellspacing="0" class="table table-striped table-bordered select" style="overflow-x: auto; display: inline-block; table-layout: fixed;">
                                                        <thead>
                                                          <tr>

                                                            <th style="text-align: center; width: 30%" > Nombre</th>
                                                            <th style="text-align: center; width: 30%">Sueldo Base</th>
                                                            {% for i in bono_item %}
                                                            <th style="text-align: center">{{i.name}}<div data-toggle="tooltip" title='{{i.description}}' class="fas fa-info-circle" style="text-align: right"></div></th>
                                                            {% endfor %}
                                                          </tr>
                                                        </thead>
                                                        <tbody>
                                                            {% for object in bonification %}
                                                                <tr>
                                                                    <td style = "text-align: center; width: 30%">{{object.0}}</td>
                                                                    <td style = "text-align: center; width: 30%"><input id="number" style = "text-align: center" type="number" defaultValue = "{{object.1}}" value="{{object.1}}"></td>
                                                                    {% for aux in object.2 %}
                                                                    <td style = "text-align: center"><input id="number" style = "text-align: center" type="number" defaultValue = "{{aux}}" value="{{aux}}"></td>
                                                                    {% endfor %} 
                                                                </tr>
                                                            {% endfor %}
                                                        </tbody>
                                                    </table>
                                                    <!-- end col-8 -->
                                                </div>
                                                <!-- end row -->
                                            </fieldset>
                                            <!-- end fieldset -->
                                        </div>
                                        <div id="step-3">
                                            <!-- begin fieldset -->
                                            <fieldset> 
                                                <!-- begin row -->
                                                <div>
                                                    <!--<button type="button" onclick="discountSum()">Prueba</button>-->
                                                    <!-- begin col-8 -->
                                                    <table id="discount-list" cellspacing="0"  class="table table-striped table-bordered select" style="overflow-x: auto; display: inline-block; table-layout: fixed;">
                                                        <thead>
                                                          <tr>
                                                            <th style="text-align: center; width: 30%">Nombre</th>
                                                            <th style="text-align: center; width: 30%">Sueldo Base</th>
                                                            {% for i in discount_item %}
                                                            <th style="text-align: center">{{i.name}}<div data-toggle="tooltip" title='{{i.description}}' class="fas fa-info-circle" style="text-align: right"></div></th>
                                                            {% endfor %}
                                                          </tr>
                                                        </thead>
                                                        <tbody>
                                                            {% for object in discountation %}
                                                                <tr>
                                                                    <td style = "text-align: center; width:30%">{{object.0}}</td>
                                                                    <td style = "text-align: center; width:30%">{{object.1}}</td>
                                                                    {% for aux in object.2 %}
                                                                    <td style = "text-align: center"><input id="number" style = "text-align: center" type="number" value="{{aux}}"></td>
                                                                    {% endfor %} 
                                                                </tr>
                                                            {% endfor %}
                                                        </tbody>
                                                    </table>
                                                    <!-- end col-8 -->
                                                </div>
                                                <!-- end row -->
                                            </fieldset>
                                            <!-- end fieldset -->
                                        </div>
                                        <div id="step-4">
                                            <!-- begin fieldset -->
                                            <fieldset> 
                                                <!-- begin row -->
                                                <div class ="row">
                                                    <div class="col-xl-8 ui-sortable">
                                                        <button type="button" class="btn btn-outline-primary" data-toggle="modal" data-target="#sendModal">
                                                            <i class="fa fa-plus"></i> Crear Recibos
                                                          </button>
                                                        <!-- begin col-8 -->
                                                        <br>
                                                        <br>
                                                        <table id="total-list" cellspacing="0"  class="table table-striped table-bordered select">
                                                            <thead>
                                                            <tr>
                                                                <th style="text-align: center">Nombre</th>
                                                                <th style="text-align: center">Sueldo Base</th>
                                                                <th style="text-align: center">Total por Empleado</th>
                                                            </tr>
                                                            </thead>
                                                            <tbody>
                                                                {% for object in workers_total %}
                                                                    <tr>
                                                                        <td style = "text-align: center">{{object.0}}</td>
                                                                        <td style = "text-align: center">{{object.1}}</td>
                                                                        <td style = "text-align: center">{{object.2}}</td>
                                                                    </tr>
                                                                {% endfor %}
                                                            </tbody>
                                                        </table>
                                                        <!-- end col-8 -->
                                                    </div>
                                                    <div class="col-xl-4 ui-sortable" style="text-align: center;">
                                                        <br>
                                                        <div id = "totalBox" class="square">
                                                            Suma Total: 0$
                                                        </div>
                                                    </div>
                                                </div>

                                                <!-- end row -->
                                            </fieldset>
                                            <!-- end fieldset -->
                                        </div>
                                    </div>
                                </div>
							</div>
						</div>
						<!-- end panel-body -->
						</div>
						<!-- end panel -->
						</div>
						</div>
						<!-- end row -->
						
						<!-- begin scroll to top btn -->
						<a href="javascript:;" class="btn btn-icon btn-circle btn-success btn-scroll-to-top fade" data-click="scroll-top"><i class="fa fa-angle-up"></i></a>
						<!-- end scroll to top btn -->
                        <div id="sendModal" class="modal">
                            <div class="modal-dialog" role="document">
                              <div class="modal-content">
                                <div class="modal-header">
                                  <h5 class="modal-title">Selección mes y año de los recibos</h5>
                                  <button type="button" class="close" data-dismiss="modal" aria-label="Close">
                                    <span aria-hidden="true">&times;</span>
                                  </button>
                                </div>
                                <div class="modal-body">
                                  <!-- MODAL BODY -->
                                  <form id="formSend">
                                    <fieldset>
                                      <div class="form-group">
                                        <div id = "inputA"></div>
                                      </div>
                                      <div class="form-group">
                                        <div id = "inputB"></div>
                                      </div>
                                      <div class="form-group">
                                        <label for="selectedBank" class="control-label m-r-10">Seleccione Cuenta Bancaria</label>
                                        <select id="selectedBank" class="form-control">
                                          <option value="">--------</option>
                                          {% for bank_account in bank_accounts %}
                                            <option value="{{ bank_account.0 }}">{{ bank_account.1 }}</option>
                                          {% endfor %}
                                        </select>
                                      </div>
                                    </fieldset>
                                  </form>
                                  <!-- END MODAL BODY -->
                                </div>
                                <div class="modal-footer">
                                  <button type="button" class="btn btn-primary" data-dismiss="modal" onclick="sendInfo();">Crear Recibos</button>
                                  <button type="button" class="btn btn-secondary" data-dismiss="modal">Cerrar</button>
                                </div>
                              </div>
                            </div>
                          </div>
						
						{% endblock %}

{% block pageleveljs %}
<script type="text/javascript">
    //active menu
    document.getElementById("hr_menu").classList.add("active");
    //active submenu item
    document.getElementById("bonification_item").classList.add("active");
</script>

<script src="{% static 'theme/plugins/smartwizard/dist/js/jquery.smartWizard.js' %} "></script>
<script src="{% static 'assets/plugins/datatables.net/jquery.dataTables.min.js' %}" defer></script>
<script src="{% static 'assets/plugins/datatables.net-bs4/js/dataTables.bootstrap4.min.js' %}" defer></script>
<script src="{% static 'assets/plugins/datatables.net-responsive/js/dataTables.responsive.min.js' %}" defer></script>
<script src="{% static 'assets/plugins/datatables.net-responsive-bs4/js/responsive.bootstrap4.min.js' %}" defer></script>
<script src="{% static 'assets/plugins/datatables.net-select/js/dataTables.select.min.js' %}" defer></script>
<!--<script src="{% static 'assets/plugins/select/select.js' %}" defer></script>-->
<script type="text/javascript" src="{% static 'theme/build/js/pages/worker-list-wizard.js' %}"></script>
<script type="text/javascript" src="{% static 'theme/build/js/pages/jquery.json-editor.min.js' %}"></script>

<script>
    get = function(obj, key) {
	return key.split(".").reduce(function(o, x) {
	    return (typeof o == "undefined" || o === null) ? o : o[x];
	}, obj);
    }

    var csrftoken = $("[name=csrfmiddlewaretoken]").val();
    $.ajaxSetup({
    beforeSend: function(xhr, settings) {
        xhr.setRequestHeader("X-CSRFToken", csrftoken);
    }});

    var month = ["Enero", "Febrero", "Marzo", "Abril", "Mayo", "Junio", "Julio",
                 "Agosto", "Septiembre", "Octubre", "Noviembre", "Diciembre"];

    var input = document.createElement("select");
    input.className = "form-control";
    for (i = 0; i < month.length; ++i )
    {
        var option = document.createElement("option");
        option.value = month[i];
        option.text = month[i];
        input.appendChild(option);
    }
    var valueLabel = document.createElement("Label");
    valueLabel.innerHTML = "Seleccione el mes";
    input.id = "selectedMonth";
    var parent = document.getElementById("inputA");
    parent.innerHTML = '';
    parent.appendChild(valueLabel);
    parent.appendChild(input);

    var input = document.createElement("input");
    input.type = "number";
    input.className = "form-control";

    var valueLabel = document.createElement("Label");
    valueLabel.innerHTML = "Seleccione el año";
    input.id = "selectedYear";
    var parent = document.getElementById("inputB");
    parent.innerHTML = '';
    parent.appendChild(valueLabel);
    parent.appendChild(input);

	// Función para activar Wizard
	var handleBootstrapWizards = function() {
	$('#wizard').smartWizard({ 
		selected: 0, 
		theme: 'default',
		transitionEffect:'',
		transitionSpeed: 0,
		useURLhash: false,
		showStepURLhash: false,
		toolbarSettings: {
			toolbarPosition: 'bottom',
		},
		anchorSettings: {
          anchorClickable: true, // Enable/Disable anchor navigation
          enableAllAnchors: true, // Activates all anchors clickable all times
          markDoneStep: false, // add done css
          enableAnchorOnDoneStep: true // Enable/Disable the done steps navigation
      	},
		});
	};
	var FormWizard = function () {
		return {
			//main function
			init: function () {
				handleBootstrapWizards();
			}
		};
	}();
	$(document).ready(function() {
        $('[data-toggle="tooltip"]').tooltip();   

		FormWizard.init();

        var bonoTable = $("#bonification-list").DataTable({
            pageLength: 10,
            searching: true,
            aLengthMenu: false,
            info: false,
            ordering: false,
            bLengthChange: false,
            initComplete: function() {
               emptyTable('bonification');
            },
        });
        var discountTable = $("#discount-list").DataTable({
            pageLength: 10,
            searching: true,
            aLengthMenu: false,
            info: false,
            ordering: false,
            bLengthChange: false,
            initComplete: function() {
               emptyTable('discount');
            },
        });
        var totalTable = $("#total-list").DataTable({
            pageLength: 10,
            searching: false,
            aLengthMenu: false,
            info: false,
            ordering: false,
            bLengthChange: false,
        });
	});

    $("#wizard").on("showStep", function(e, anchorObject, stepIndex, stepDirection) {
        if (stepIndex == 3 )
        {
            calculate();
        }
    });

    $('#worker-list-wizard').on('click', 'tbody tr input', function () {
            var x = $(this).closest('tr');
            var dt = $('#worker-list-wizard').DataTable();
            var bdt = $('#bonification-list').DataTable();
            var ddt = $('#discount-list').DataTable();
        
            var index = -1
            
            for ( var i = 0; i < dt.rows().data().length; ++i )
            {
                if (dt.rows($(this).parents('tr')).data()[0]['pk'] == dt.rows(i).data()[0]['pk'])
                {
                    index = i;
                    break;
                }
            }
            
            if (x.hasClass('selected')) {
                console.log('remove');
                x.removeClass('selected');
                x.addClass('notSelected');

               emptyRow(index,'bonification');
               emptyRow(index, 'discount');
            }
            else {
                console.log('add');
                x.addClass('selected');
                x.removeClass('notSelected');

               defaultRow(index, 'bonification');
               defaultRow(index, 'discount');
            }
        });
    
    function selectAll()
    {
        var dt = $('#worker-list-wizard').DataTable();
        dt.rows().every(function() {
            this.nodes().to$().addClass('selected');
            this.nodes().to$().removeClass('notSelected');
        })
        var z = dt.$('input');
        for (var i = 0; i < z.length; ++i )
        {
            z[i].checked = true;
        }
       defaultTable('bonification');
       defaultTable('discount');
    }
    function deselectAll()
    {
        var dt = $('#worker-list-wizard').DataTable();
        dt.rows().every(function() {
            this.nodes().to$().removeClass('selected');
            this.nodes().to$().addClass('notSelected');
        })
        var z = dt.$('input');
        for (var i = 0; i < z.length; ++i )
        {
            z[i].checked = false;
        }
       emptyTable('bonification');
       emptyTable('discount');
    }
    
    function emptyTable(table)
    {
        if (table == 'bonification'){
            var dt = $('#bonification-list').DataTable();
        }else if ( table == 'discount'){
            var dt = $('#discount-list').DataTable();
        }
        for ( var i = 0; i < dt.rows().data().length; ++i )
        {
            emptyRow(i, table);
        }

    }
    function emptyRow(row, table)
    {
        first = 0
        if (table == 'bonification'){
            var dt = $('#bonification-list').DataTable();
            first =  1
        }else if ( table == 'discount'){
            var dt = $('#discount-list').DataTable();
            first = 2
        }
        for (var i = first; i < dt.rows(row).data()[0].length; ++i )
        {
            if ($(dt.cell(row,i).node()).find('input'))
            {
                $(dt.cell(row,i).node()).find('input').val(0)
            }
        }
    }

    function defaultTable(table)
    {
        if (table == 'bonification'){
            var dt = $('#bonification-list').DataTable();
        }else if ( table == 'discount'){
            var dt = $('#discount-list').DataTable();
        }
        for ( var i = 0; i < dt.rows().data().length; ++i )
        {
            defaultRow(i, table);
        }

    }
    function defaultRow(row, table)
    {
        first = 0
        if (table == 'bonification'){
            var dt = $('#bonification-list').DataTable();
            first = 1
        }else if ( table == 'discount'){
            var dt = $('#discount-list').DataTable();
            first = 2
        }
        for (var j = first; j < dt.rows(row).data()[0].length; ++j )
        {
            var deflt = parseFloat($(dt.cell(row,j).node()).find('input')[0].defaultValue);
            if ($(dt.cell(row,j).node()).find('input'))
            {
                $(dt.cell(row,j).node()).find('input').val(deflt);
            }
        }

    }
    function tableSum(table)
    {
        if (table == 'bonification'){
            var dt = $('#bonification-list').DataTable();
        }else if ( table == 'discount'){
            var dt = $('#discount-list').DataTable();
        }
        var sum_list = []
        for ( var i = 0; i < dt.rows().data().length; ++i )
        {
            var suma = 0
            for (var j = 2; j < dt.rows(i).data()[0].length; ++j )
            {
                if ($(dt.cell(i,j).node()).find('input'))
                {
                    suma = suma + parseFloat($(dt.cell(i,j).node()).find('input').val());
                }
            }
            sum_list.push(suma);
        }
        return sum_list;
    }

    function calculate()
    {
        var b = tableSum('bonification');
        var d = tableSum('discount');
        var wl = $('#worker-list-wizard').DataTable();
        var dt = $('#total-list').DataTable();
        var bt = $('#bonification-list').DataTable();
        var sumaTotal = 0;
        for (var i = 0; i < dt.rows().data().length; ++i )
        {
            if ( $(wl.row(i).node()).hasClass('selected')){
                total = parseFloat($(bt.cell(i,1).node()).find('input').val()) + b[i] - d[i];
            } else {
                total = 0;
            }
            $(dt.cell(i,2).node()).text(total)
            sumaTotal = sumaTotal + total;
        }
        var totalBox = document.getElementById('totalBox');
        sumaTotal = sumaTotal.toString();
        totalBox.innerHTML = 'Suma Total: ' + sumaTotal + ' $';

    }

    function getInfo()
    {
        var dt = $('#worker-list-wizard').DataTable();
        var bdt = $('#bonification-list').DataTable();
        var ddt = $('#discount-list').DataTable();
        var tdt = $('#total-list').DataTable();
        var b = tableSum('bonification');
        var d = tableSum('discount');
        b_names = []
        d_names = []
        bdt.columns().header().each(function(v) { b_names.push($(v).text()) });
        ddt.columns().header().each(function(v) { d_names.push($(v).text()) });

        workers_info = []
        for (var i = 0; i < dt.rows().data().length; ++i )
        {
            if ($(dt.row(i).node()).hasClass('selected'))
            {
                worker_info = [];
                worker_bono_info = [];
                worker_disc_info = [];
                total_amount = parseFloat($(bdt.cell(i,1).node()).find('input').val()) + b[i] - d[i];
                worker_info.push(dt.rows(i).data()[0]['pk']);
                worker_info.push(dt.rows(i).data()[0]['name']);
                worker_info.push(total_amount);

                for (var j = 2; j < b_names.length; ++ j )
                {
                    worker_bono_info.push([b_names[j],$(bdt.cell(i,j).node()).find('input').val()])
                }
                worker_info.push(worker_bono_info);

                for (var j = 2; j < d_names.length; ++j )
                {
                    worker_disc_info.push([d_names[j],$(ddt.cell(i,j).node()).find('input').val()])
                }
                worker_info.push(worker_disc_info);

                workers_info.push(worker_info);
            }
        }
        return workers_info;
    }

    function sendInfo()
	{	
        
        var send_data = getInfo();
        data = {
            "data": JSON.stringify(send_data),
            "month": document.getElementById("selectedMonth").value,
            "year": document.getElementById("selectedYear").value,
            "bank_account": document.getElementById("selectedBank").value,
        }
        var url = '{% url "receive-info" %}';
        console.log(url);
		var result = $.ajax({
            type: 'POST',
            url: url,
            data: data,
			datatype: "json",
			async: false,
            success: function(datos)
            {
                alert("Se han creado los recibos exitosamente.");
            }
        });
	}

    
</script>

{% endblock %}
